package
{
	import flash.utils.Timer;
	
	import mx.core.UIComponent;

	public dynamic class Clock2 extends Label
	{
		private var ticker:Timer;
		
		public function initClock()
		{
			// creates a Timer that fires an event once per second 
			ticker = new Timer(1000); 
			// designates the onTick() method to handle Timer events 
			ticker.addEventListener(TimerEvent.TIMER, onTick); 
			// starts the clock ticking 
			ticker.start();
		}
		
		public function onTick(event:TimerEvent):void 
		{ 
			// updates the clock display 
			currentTime = new Date();
			var seconds:uint = currentTime.getSeconds();
        	var minutes:uint = currentTime.getMinutes();
        	var hours:uint = currentTime.getHours();
        	var day:uint = currentTime.getDay();
			var date:uint = currentTime.getDate();
			var month:uint = currentTime.getMonth();
			var year:uint = currentTime.getFullYear();
			time = format.format(currentTime).toString();
			face.draw(); 
		}
		
		/** 
		 * Called by the parent container when the display is being drawn. 
		 */ 
		public override function draw():void 
		{ 
		// stores the current date and time in an instance variable 
		currentTime = new Date(); 
		showTime(currentTime); 
		} 
		
		/** 
		 * Displays the given Date/Time in that good old analog clock style. 
		 */ 
		public function showTime(time:Date):void 
		{ 
		// gets the time values 
		var seconds:uint = time.getSeconds(); 
		var minutes:uint = time.getMinutes(); 
		var hours:uint = time.getHours(); 
		// multiplies by 6 to get degrees 
		this.secondHand.rotation = 180 + (seconds * 6); 
		this.minuteHand.rotation = 180 + (minutes * 6); 
		// Multiply by 30 to get basic degrees, then 
		// add up to 29.5 degrees (59 * 0.5) 
		// to account for the minutes. 
		this.hourHand.rotation = 180 + (hours * 30) + (minutes * 0.5); 
		} 

		
	}
}