package com.winnb.locator.data
{
    public class MarkerVO implements IDBEntry
    {
        public var id:int;
        public var locationId:int;
        public var jsId:String;
        public var caption:String;
        public var x:Number;
        public var y:Number;
        
        public function MarkerVO( id:int = -1, 
                                    locationId:int = -1,
                                    jsId:String = "",
                                    caption:String = "",
                                    xpos:Number = 0, ypos:Number = 0 )
        {
            this.id = id;
            this.locationId = locationId;
            this.jsId = jsId;
            this.caption = caption;
            this.x = xpos;
            this.y = ypos;
        }
        
        public function serialize():void
        {
            caption = escape( caption );
        }
        public function deserialize():void
        {
            caption = unescape( caption );
        }
        
        public static function create( value:Object ):MarkerVO
        {
            var marker:MarkerVO = null;
            try
            {
                marker = new MarkerVO();
                for( var prop:String in value )
                {
                    marker[prop] = value[prop];
                }
                marker.deserialize();
                
            }
            catch( e:Error ) {}
            return marker;
        }
    }
}