package com.winnb.locator.util
{
    import flash.display.BitmapData;
    import flash.display.DisplayObject;
    import flash.filesystem.File;
    import flash.filesystem.FileMode;
    import flash.filesystem.FileStream;
    import flash.utils.ByteArray;
    
    import mx.graphics.codec.PNGEncoder;
    
    public class ImageFileBuffer
    {
        private static const STORAGE_DIR:String = "app-storage:/";
        public static const FILE_EXTENSION:String = ".png";
        
        public static function bufferImage( target:DisplayObject, name:String,
                                                w:Number = 0, h:Number = 0 ):String
        {
            var width:Number = ( w == 0 ) ? target.width : w;
            var height:Number = ( h == 0 ) ? target.height : h;
            var file:File = new File();
            file.url = STORAGE_DIR;
            file = file.resolvePath( name + FILE_EXTENSION );
            var bmp:BitmapData = new BitmapData( width, height );
            bmp.draw( target );
            var bytes:ByteArray = new PNGEncoder().encode( bmp );  
            var stream:FileStream = new FileStream();
            stream.open( file, FileMode.WRITE );
            stream.writeBytes( bytes );
            stream.close();

            return STORAGE_DIR + file.name;
        }
    }
}